<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfContasBancariasERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfContasBancariasERP
 * @subpackage Arrays
 */
class ArrayOfContasBancariasERP extends AbstractStructArrayBase
{
    /**
     * The ContasBancariasERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ContasBancariasERP[]
     */
    public $ContasBancariasERP;
    /**
     * Constructor method for ArrayOfContasBancariasERP
     * @uses ArrayOfContasBancariasERP::setContasBancariasERP()
     * @param \StructType\ContasBancariasERP[] $contasBancariasERP
     */
    public function __construct(array $contasBancariasERP = array())
    {
        $this
            ->setContasBancariasERP($contasBancariasERP);
    }
    /**
     * Get ContasBancariasERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ContasBancariasERP[]|null
     */
    public function getContasBancariasERP()
    {
        return isset($this->ContasBancariasERP) ? $this->ContasBancariasERP : null;
    }
    /**
     * Set ContasBancariasERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ContasBancariasERP[] $contasBancariasERP
     * @return \ArrayType\ArrayOfContasBancariasERP
     */
    public function setContasBancariasERP(array $contasBancariasERP = array())
    {
        foreach ($contasBancariasERP as $arrayOfContasBancariasERPContasBancariasERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfContasBancariasERPContasBancariasERPItem instanceof \StructType\ContasBancariasERP) {
                throw new \InvalidArgumentException(sprintf('The ContasBancariasERP property can only contain items of \StructType\ContasBancariasERP, "%s" given', is_object($arrayOfContasBancariasERPContasBancariasERPItem) ? get_class($arrayOfContasBancariasERPContasBancariasERPItem) : gettype($arrayOfContasBancariasERPContasBancariasERPItem)), __LINE__);
            }
        }
        if (is_null($contasBancariasERP) || (is_array($contasBancariasERP) && empty($contasBancariasERP))) {
            unset($this->ContasBancariasERP);
        } else {
            $this->ContasBancariasERP = $contasBancariasERP;
        }
        return $this;
    }
    /**
     * Add item to ContasBancariasERP value
     * @throws \InvalidArgumentException
     * @param \StructType\ContasBancariasERP $item
     * @return \ArrayType\ArrayOfContasBancariasERP
     */
    public function addToContasBancariasERP(\StructType\ContasBancariasERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ContasBancariasERP) {
            throw new \InvalidArgumentException(sprintf('The ContasBancariasERP property can only contain items of \StructType\ContasBancariasERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ContasBancariasERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ContasBancariasERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ContasBancariasERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ContasBancariasERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ContasBancariasERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ContasBancariasERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ContasBancariasERP
     */
    public function getAttributeName()
    {
        return 'ContasBancariasERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfContasBancariasERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
